Subject: Re: bug#36649: 27.0.50; pure space and pdumper

From: Paul Eggert <[email-masked]>
Date: Thu, 4 Mar 2021 13:52:29 -0800

On 3/4/21 6:56 AM, Robert Pluim wrote:
>      Pip> - zero vector handling depends on Qnil being all zero in memory
> 
> I think Emacs already assumes Qnil == 0, since there are places that
> use ! to check for Qnil rather than using NILP.

The convention is to put a "verify (NIL_IS_ZERO);" near the rare bits of 
code that assume Qnil is all-bits-zero. This is to help out any 
hypothetical future developer who wants to change Qnil to be some other 
value. Currently there are only two such locations. (There is one other 
location that uses NIL_IS_ZERO for an optimization.)